#!/bin/bash
#Don't run it from here!

#date=$(date +"%Y%m%d-%H%M%S")

echo 
sfkbin=./sfk
unameOut="$(uname -s)"
case "${unameOut}" in
    CYGWIN*)    sfkbin=./sfk.exe;;
	MINGW*)    sfkbin=./sfk.exe;;
	MSYS*)    sfkbin=./sfk.exe;;
esac

if ls ../new/save/games/*.sav 1> /dev/null 2>&1;  then
    echo "Good! New game save files found:"&& echo && ls -1 ../new/save/games/ && echo
else
    echo "ERROR: Game save files not found in ./new/save/games/ directory"
	sleep 2; exit 1
fi

if ls ../old/save/characters/*.lpl 1> /dev/null 2>&1;  then
    echo "Good! Old characters save files found:"
	charfile=true
	#mkdir -p "../backup/" && tar -zcvf "../backup/backup-$date.tar.gz" "../old/save/characters/characters.lpl" "../old/save/games/" "../old/save/net/" &>/dev/null
else
    echo "WARNING: characters.lpl not found in ./old/save/characters/ directory"
	charfile=false
	sleep 1
fi

if ls ../old/save/games/*.sav 1> /dev/null 2>&1;  then
    echo "Good! Old game save files found:" && echo && ls -1 ../old/save/games/ && echo
    gamefile=true
else
    echo "WARNING: save files not found in ./old/save/characters/ directory"
    gamefile=false
	sleep 1
fi


if [ "$charfile" == "true" ]; then
echo && ls -1 ../old/save/characters/ && echo
elif [ "$gamefile" == "false" ]; then
echo
echo "ERROR: files not found in ./old/save/ directory"
echo Copy your old saves in ./old/save/ folder!
echo example: ./old/save/games/game.sav
echo example: ./old/save/characters/characters.lpl
echo
echo exiting with errors..
sleep 1
exit 1
fi

mkdir -p "../new/save/games/" "../new/save/characters/" "../old/save/games/" "../old/save/characters/"

find "../new/save/games/" -type f ! -name '*.sav' -delete
ls -t1 "../new/save/games/" | head -n 1 >latest.txt
file="./latest.txt"
name=$(cat "$file")
echo Latest save is "$name"
echo
head -c 256 "../new/save/games/$name"> header.bin; echo the header created from "$name"
mkdir -p "../fixed/save/games/" "../fixed/save/characters/"
cp  -r "../old/save/games/" "../fixed/save/"
cp  -r "../old/save/characters/" "../fixed/save/"


if [ "$charfile" == "true" ]; then for file in ../fixed/save/games/*.sav ; do $sfkbin partcopy ./header.bin 0 256 "$file" 0x0000 -yes ; done; echo "$file" file patched; fi
if [ "$gamefile" == "true" ]; then for file in ../fixed/save/characters/*.lpl ; do $sfkbin partcopy ./header.bin 0 256 "$file" 0x0000 -yes ; done; echo "$file" file patched; fi

echo
echo All done!