#!/bin/bash

# Cygwin compatibility
busybin=./busybox
unameOut="$(uname -s)"
case "${unameOut}" in
    CYGWIN*)    busybin=./busybox.exe;;
	MINGW*)    busybin=./busybox.exe;;
	MSYS*)    busybin=./busybox.exe;;
esac

echo "Script executed from: ${PWD}"

BASEDIR=$(dirname $0)
echo "Script location: ${BASEDIR}"

cd ${BASEDIR}
echo
echo now, current dir is ${PWD}


# launcher
cd ./system
$busybin sh ./script.sh
read -p 'Press [Enter] key to continue...'